Components.utils.import("resource://gre/modules/Services.jsm");

var responses = [
  {
    "name": "Customer Success::Address Upset Customer",
    "url": "chrome://pbresponses/content/responses/Customer Success--Address Upset Customer.html"
  },
  {
    "name": "Customer Success::Asking for Feedback",
    "url": "chrome://pbresponses/content/responses/Customer Success--Asking for Feedback.html"
  },
  {
    "name": "Customer Success::Trial Follow-up",
    "url": "chrome://pbresponses/content/responses/Customer Success--Trial Follow-up.html"
  },
  {
    "name": "Hiring::Rejection Letter - Specific Job",
    "url": "chrome://pbresponses/content/responses/Hiring--Rejection Letter - Specific Job.html"
  },
  {
    "name": "Hiring::Rejection Letter - Unsolicited Resume",
    "url": "chrome://pbresponses/content/responses/Hiring--Rejection Letter - Unsolicited Resume.html"
  },
  {
    "name": "Hiring::Job Inquiry Response 1",
    "url": "chrome://pbresponses/content/responses/Hiring--Job Inquiry Response 1.html"
  },
  {
    "name": "Hiring::Job Inquiry Response 2",
    "url": "chrome://pbresponses/content/responses/Hiring--Job Inquiry Response 2.html"
  },
  {
    "name": "Hiring::Letter of Recommendation",
    "url": "chrome://pbresponses/content/responses/Hiring--Letter of Recommendation.html"
  },
  {
    "name": "Hiring::Notice of Termination",
    "url": "chrome://pbresponses/content/responses/Hiring--Notice of Termination.html"
  },
  {
    "name": "Hiring::Recruiting Letter",
    "url": "chrome://pbresponses/content/responses/Hiring--Recruiting Letter.html"
  },
  {
    "name": "Hiring::References Request 1",
    "url": "chrome://pbresponses/content/responses/Hiring--References Request 1.html"
  },
  {
    "name": "Hiring::References Request 2",
    "url": "chrome://pbresponses/content/responses/Hiring--References Request 2.html"
  },
  {
    "name": "Hiring::Welcome Email",
    "url": "chrome://pbresponses/content/responses/Hiring--Welcome Email.html"
  },
  {
    "name": "Introductions::Collaboration Request 1",
    "url": "chrome://pbresponses/content/responses/Introductions--Collaboration Request 1.html"
  },
  {
    "name": "Introductions::Collaboration Request 2",
    "url": "chrome://pbresponses/content/responses/Introductions--Collaboration Request 2.html"
  },
  {
    "name": "Introductions::Collaboration Request 3",
    "url": "chrome://pbresponses/content/responses/Introductions--Collaboration Request 3.html"
  },
  {
    "name": "Introductions::Collaboration Request 4",
    "url": "chrome://pbresponses/content/responses/Introductions--Collaboration Request 4.html"
  },
  {
    "name": "Introductions::Collaboration Request 5",
    "url": "chrome://pbresponses/content/responses/Introductions--Collaboration Request 5.html"
  },
  {
    "name": "Introductions::Introducing Two People 1",
    "url": "chrome://pbresponses/content/responses/Introductions--Introducing Two People 1.html"
  },
  {
    "name": "Introductions::Introducing Two People 2",
    "url": "chrome://pbresponses/content/responses/Introductions--Introducing Two People 2.html"
  },
  {
    "name": "Introductions::Introducing Two People 3",
    "url": "chrome://pbresponses/content/responses/Introductions--Introducing Two People 3.html"
  },
  {
    "name": "Introductions::Introducing Two People 4",
    "url": "chrome://pbresponses/content/responses/Introductions--Introducing Two People 4.html"
  },
  {
    "name": "Introductions::Introducing Two People 5",
    "url": "chrome://pbresponses/content/responses/Introductions--Introducing Two People 5.html"
  },
  {
    "name": "Introductions::New Hire Braindump",
    "url": "chrome://pbresponses/content/responses/Introductions--New Hire Braindump.html"
  },
  {
    "name": "Introductions::Set Up a Phone Call 1",
    "url": "chrome://pbresponses/content/responses/Introductions--Set Up a Phone Call 1.html"
  },
  {
    "name": "Introductions::Set Up a Phone Call 2",
    "url": "chrome://pbresponses/content/responses/Introductions--Set Up a Phone Call 2.html"
  },
  {
    "name": "Introductions::Set Up an In-Person Meeting 1",
    "url": "chrome://pbresponses/content/responses/Introductions--Set Up an In-Person Meeting 1.html"
  },
  {
    "name": "Introductions::Set Up an In-Person Meeting 2",
    "url": "chrome://pbresponses/content/responses/Introductions--Set Up an In-Person Meeting 2.html"
  },
  {
    "name": "Investors::Asking for Advice 1",
    "url": "chrome://pbresponses/content/responses/Investors--Asking for Advice 1.html"
  },
  {
    "name": "Investors::Asking for Advice 2",
    "url": "chrome://pbresponses/content/responses/Investors--Asking for Advice 2.html"
  },
  {
    "name": "Investors::Company Update",
    "url": "chrome://pbresponses/content/responses/Investors--Company Update.html"
  },
  {
    "name": "Investors::Follow-up",
    "url": "chrome://pbresponses/content/responses/Investors--Follow-up.html"
  },
  {
    "name": "Investors::Investor Pitch",
    "url": "chrome://pbresponses/content/responses/Investors--Investor Pitch.html"
  },
  {
    "name": "Job Search::Cover Letter - Specific Job 1",
    "url": "chrome://pbresponses/content/responses/Job Search--Cover Letter - Specific Job 1.html"
  },
  {
    "name": "Job Search::Cover Letter - Specific Job 2",
    "url": "chrome://pbresponses/content/responses/Job Search--Cover Letter - Specific Job 2.html"
  },
  {
    "name": "Job Search::Cover Letter - Specific Job 3",
    "url": "chrome://pbresponses/content/responses/Job Search--Cover Letter - Specific Job 3.html"
  },
  {
    "name": "Job Search::Cover Letter - Specific Job 4",
    "url": "chrome://pbresponses/content/responses/Job Search--Cover Letter - Specific Job 4.html"
  },
  {
    "name": "Job Search::Cover Letter - Unsolicited Resume 1",
    "url": "chrome://pbresponses/content/responses/Job Search--Cover Letter - Unsolicited Resume 1.html"
  },
  {
    "name": "Job Search::Cover Letter - Unsolicited Resume 2",
    "url": "chrome://pbresponses/content/responses/Job Search--Cover Letter - Unsolicited Resume 2.html"
  },
  {
    "name": "Job Search::Employment Offer - Accept",
    "url": "chrome://pbresponses/content/responses/Job Search--Employment Offer - Accept.html"
  },
  {
    "name": "Job Search::Employment Offer - Decline",
    "url": "chrome://pbresponses/content/responses/Job Search--Employment Offer - Decline.html"
  },
  {
    "name": "Job Search::Networking Request 1",
    "url": "chrome://pbresponses/content/responses/Job Search--Networking Request 1.html"
  },
  {
    "name": "Job Search::Networking Request 2",
    "url": "chrome://pbresponses/content/responses/Job Search--Networking Request 2.html"
  },
  {
    "name": "Job Search::Networking Request 3",
    "url": "chrome://pbresponses/content/responses/Job Search--Networking Request 3.html"
  },
  {
    "name": "Job Search::Recruiter Response - Accept",
    "url": "chrome://pbresponses/content/responses/Job Search--Recruiter Response - Accept.html"
  },
  {
    "name": "Job Search::Recruiter Response - Decline",
    "url": "chrome://pbresponses/content/responses/Job Search--Recruiter Response - Decline.html"
  },
  {
    "name": "Job Search::References Request 1",
    "url": "chrome://pbresponses/content/responses/Job Search--References Request 1.html"
  },
  {
    "name": "Job Search::References Request 2",
    "url": "chrome://pbresponses/content/responses/Job Search--References Request 2.html"
  },
  {
    "name": "Misc::Debt Collection Email 1",
    "url": "chrome://pbresponses/content/responses/Misc--Debt Collection Email 1.html"
  },
  {
    "name": "Misc::Debt Collection Email 2",
    "url": "chrome://pbresponses/content/responses/Misc--Debt Collection Email 2.html"
  },
  {
    "name": "Misc::Follow-up Email",
    "url": "chrome://pbresponses/content/responses/Misc--Follow-up Email.html"
  },
  {
    "name": "Press::Product Pitch 1",
    "url": "chrome://pbresponses/content/responses/Press--Product Pitch 1.html"
  },
  {
    "name": "Press::Product Pitch 2",
    "url": "chrome://pbresponses/content/responses/Press--Product Pitch 2.html"
  },
  {
    "name": "Sales::Follow Up 1",
    "url": "chrome://pbresponses/content/responses/Sales--Follow Up 1.html"
  },
  {
    "name": "Sales::Follow Up 2",
    "url": "chrome://pbresponses/content/responses/Sales--Follow Up 2.html"
  },
  {
    "name": "Sales::Follow Up 3",
    "url": "chrome://pbresponses/content/responses/Sales--Follow Up 3.html"
  },
  {
    "name": "Sales::Follow Up 4",
    "url": "chrome://pbresponses/content/responses/Sales--Follow Up 4.html"
  },
  {
    "name": "Sales::Follow Up 5",
    "url": "chrome://pbresponses/content/responses/Sales--Follow Up 5.html"
  },
  {
    "name": "Sales::Follow Up 6",
    "url": "chrome://pbresponses/content/responses/Sales--Follow Up 6.html"
  },
  {
    "name": "Sales::Getting Back in Touch 1",
    "url": "chrome://pbresponses/content/responses/Sales--Getting Back in Touch 1.html"
  },
  {
    "name": "Sales::Getting Back In Touch 2",
    "url": "chrome://pbresponses/content/responses/Sales--Getting Back In Touch 2.html"
  },
  {
    "name": "Sales::Getting Back in Touch 3",
    "url": "chrome://pbresponses/content/responses/Sales--Getting Back in Touch 3.html"
  },
  {
    "name": "Sales::Prospect Email 1",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 1.html"
  },
  {
    "name": "Sales::Prospect Email 2",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 2.html"
  },
  {
    "name": "Sales::Prospect Email 3",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 3.html"
  },
  {
    "name": "Sales::Prospect Email 4",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 4.html"
  },
  {
    "name": "Sales::Prospect Email 5",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 5.html"
  },
  {
    "name": "Sales::Prospect Email 6",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 6.html"
  },
  {
    "name": "Sales::Prospect Email 7",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 7.html"
  },
  {
    "name": "Sales::Prospect Email 8",
    "url": "chrome://pbresponses/content/responses/Sales--Prospect Email 8.html"
  },
]

var gListbox = null;
var gBrowser = null;

function onLoad() {
  gListbox = document.getElementById("responses-listbox");
  gBrowser = document.getElementById("responses-browser");
  gResponseService = Components.classes["@postbox-inc.com/cannedresponses;1"].getService(Components.interfaces.pbISignatureService);
  responses.forEach(function(response) {
    gListbox.appendItem(response.name, response.url);
  });
  gListbox.addEventListener("select", onResponseSelected, false);
  window.setTimeout(function() {
    gListbox.selectedIndex = 0;
  })
}

function onAdd(event) {
  var selectedItem = gListbox.selectedItem;
  var retVals = { name: selectedItem.label};
  window.openDialog("chrome://pbresponses/content/prompt.xul", "pbresponses-prompt", "modal,centerscreen", retVals);
  if (retVals.cancel) {
    return;
  }
  var request = new XMLHttpRequest();
  request.mozBackgroundRequest = true;
  request.open("GET", selectedItem.value, false);
  request.send();
  gResponseService.add(retVals.name, request.responseText);
}

function onResponseSelected(event) {
  var request = new XMLHttpRequest();
  request.mozBackgroundRequest = true;
  request.open("GET", gListbox.selectedItem.value, false);
  request.send();
  var doc = gBrowser.contentDocument;
  doc.getElementById("response").innerHTML = request.responseText;
}
